% A quick reminder regarding the Newton's method.
% It is a method of finding the (successively better) approximations to the
% roots of a function F, that is, finding x such that 
%                         F(x) = 0
% The algorithm is performed as follows; given an initial guess x0, the
% function F and its derivative DF, we compute
%
%       x_{n+1} = x_n - (DF(x_n))^{-1} * F(x_n),  for n = 0, 1, 2,
%
% The iterations are performed until we reach a sufficiently accurate
% approximation (e.g., when |F(x_{n+1})| < tol where tol is some small
% value, or if iterations are getting close to each other). As a last
% resort, the algorithm will be stopped if we reach some preset maximum 
% number of iterations.

function [ ] = Newton( )
    % You have to decide and set your output and input for the Newton. 
    % Among other things, your code should contain MaxIt, tol, the function
    % whose root you are trying to find, and its Jacobian, and possible  
    % further variables
    
    
    % Set the first guess needed to initialise Newton's method
    
    
    % Loop until we either reach the preset maximum number of iterations or
    % until the stopping criteria 
    for i = 1:MaxIt
        % Make sure that the discriminant of the Jacobian is not singular
        % You can also comment this line out if the code is too slow or if 
        % are unsure what to do.
        assert(det( ) )~=0);
        % Perform the Newton iteration
        
        if norm()<tol % Stop if the current iterate is close enough to the solution
            break
        end
    end
  
    % If needed, set the output